############################################################################
##
## Copyright (c) 2000-2001 BalaBit IT Ltd, Budapest, Hungary
## All rights reserved.
##
## $Id: ListenerConfig.py,v 1.7 2002/10/22 11:01:50 sasa Exp $
##
############################################################################

import UIUtils
from Config import Config
from snack import *
from ZUI.Lang import *

prev_listener = 'SockAddrInet("192.168.1.1", 50080)'

class ListenerConfig(Config):

    def __init__(self, owner, addr):
        self.owner = owner
        self.addr = addr
        self.service = ""

    def generateConfig(self, output, gi):
        output.write('\t' * gi.indent_level)
        if self.service:
            output.write('Listener(%s, "%s")\n' % (self.addr, self.service.name))
        else:
            output.write('Listener(%s, NoService)\n' % self.addr)

    def runForm(self):
        screen = UIUtils.screen
        form = GridForm(screen, mylang.get("Edit Listener"), 2, 1)
        
        leftgrid = Grid(1, 4)
        addr_l = Label(mylang.get("Address"))
        addr = Entry(40, self.addr, returnExit=1)
        
        service_l = Label(mylang.get("Service"))
        service = Listbox(height=5, width=40, scroll=1, border=1, returnExit=1)
        
        service.append(mylang.get("No service selected"), None)
        
        for s in self.owner.services.keys():
            service.append(s, self.owner.services[s])
      
   	if self.service:
   	    try:
                service.setCurrent(self.service)    
            except:
                self.service = None
        
        leftgrid.setField(addr_l, 0, 0, anchorLeft=1)
        leftgrid.setField(addr, 0, 1, padding=(0, 0, 0, 1))
        leftgrid.setField(service_l, 0, 2, anchorLeft=1)
        leftgrid.setField(service, 0, 3)
        
        main_bb = ButtonBar(screen, [(mylang.get("  Ok  "), "ok"), (mylang.get("Cancel"), "cancel")], horizontal=0, compact=1)
        
        form.add(leftgrid, 0, 0)
        form.add(main_bb, 1, 0)
        
        x = form.runOnce()
        main_action = main_bb.buttonPressed(x)
        
        if main_action == "ok" or main_action == None:
            global prev_listener
            self.addr = addr.value()
            prev_listener = addr.value()
            self.service = service.current()
