############################################################################
##
## Copyright (c) 2000-2001 BalaBit IT Ltd, Budapest, Hungary
## All rights reserved.
##
## $Id: RouterConfig.py,v 1.6 2002/10/22 11:01:50 sasa Exp $
##
############################################################################

import UIUtils
from Config import Config
from snack import *
from ZUI.Lang import *

class RouterConfig(Config):
    def __init__(self, owner, type):
        self.owner = owner
        self.type = type
        self.router_parms = {}

    def generateConfig(self, output, gi):
        if self.type == 'DirectedRouter':
            output.write('DirectedRouter(%s)' % self.router_parms["remote_addr"])
        else:
            output.write('%s()' % self.type)

    def editCustom(self):
        x = UIUtils.EntryForm(title=mylang.get("Router class name"), text="TransparentRouter").run()
        if x:
            self.type = x
            self.router_parms = {}
        
    def editTransparentRouter(self):
        pass
        
    def editDirectedRouter(self):
        # TODO: forge_addr, bind_addr
        x = UIUtils.EntryForm(title=mylang.get("Remote address"), text="SockAddrInet('192.168.1.2', 80)").run()
        if x:
            self.router_parms["remote_addr"] = x
        
    def editInbandRouter(self):
        # TODO: forge_addr, bind_addr
        pass

    def addForm(self):
        screen = UIUtils.screen
        
        grid = Grid(2, 1)
        self.label = Label(self.type + (40 - len(self.type)) * ' ')
        self.bb = ButtonBar(screen, [mylang.get("Change")], compact=1)

        grid.setField(self.label, 0, 0)
        grid.setField(self.bb, 1, 0, anchorRight=1)
        return grid
        
    def runForm(self, res):
        x = self.bb.buttonPressed(res)
        if x:
            routers = [
                'TransparentRouter',
                'InbandRouter',
                'DirectedRouter'
                ]
            screen = UIUtils.screen
            form = GridForm(screen, mylang.get('Select router to use'), 2, 1)
            
            leftgrid = Grid(1, 2)
            
            router_l = Label(mylang.get('Router class'))
            router = Listbox(width=30, height=5, scroll=1, border=1, returnExit=1)
            
            router.append(mylang.get("Custom..."), None)
            for p in routers:
                router.append(p, p)
                
            try:
                router.setCurrent(self.type)
            except KeyError:
                pass
            
            leftgrid.setField(router_l, 0, 0, anchorLeft=1)
            leftgrid.setField(router, 0, 1)
            
            main_bb = ButtonBar(screen, [(mylang.get("  Ok  "), "ok"), (mylang.get("Cancel"), "cancel")], horizontal=0)
            
            form.add(leftgrid, 0, 0)
            form.add(main_bb, 1, 0)
            
            res = form.runOnce()
            x = main_bb.buttonPressed(res)
            if x == "ok" or x == None:
                try:
                    p = router.current()
                    if p:
                        self.type = p
                        f = getattr(self, 'edit' + p)
                        f()
                    else:
                        self.editCustom()
                    self.label.setText(self.type)
                except KeyError:
                    pass
                pass
            return 1
                
            return 1
        
    def endForm(self):
        del self.bb
        del self.label
