#!/usr/bin/env python

import sys
from snack import *
from re import *
import cPickle
import traceback
from ZUI import ZorpConfig
from ZUI import Predef
from ZUI.UIUtils import *
from ZUI.Params import *
from ZUI import UIUtils

#
#################################################################################################
#


# Window title, text, help, variable name, default value, type (0=no-check,1=ip-address,2=net-address)
config_dmz_list = ( ('Intranet intersz', 'Intranet interfsz', 'Az intranet oldali interfsz azonostja.', 'intra_if', 'eth0', 0),
		('Intranet hlzati cme', 'Intranet hlzati cme ', 'Az intranet hlzati cme. (x.x.x.x/x)', 'intra_net', '', 2),
		('Intranet IP', 'Intranet oldali ip cm', 'Az intranet oldali interfsz IP cme.', 'intra_ip', '', 1),
		('DMZ intersz', 'DMZ interfsz', 'A DMZ oldali interfsz azonostja.', 'dmz_if', 'eth2', 0),
		('DMZ hlzati cme', 'DMZ hlzati cme', 'A DMZ hlzati cme. (x.x.x.x/x)', 'dmz_net', '', 2),
		('DMZ IP', 'DMZ oldali IP', 'A DMZ oldali interfsz IP cme.', 'dmz_ip', '', 1),
		('Internet interfsz', 'Internet interfsz', 'Az Internet oldali interfsz azonostja.', 'inter_if', 'eth1', 0),
		('Internet IP', 'Internet oldali IP', 'Az Internet oldali interfsz IP cme.', 'inter_ip', '', 1),
		('DNS Szerver', 'DNS szerver IP cme', 'Az Internet szolgltat DNS szervernek IP cme', 'dns_ips', '193.225.86.1', 1),
		('NTP Szerver', 'NTP szerver IP cme', 'Egy kls NTP szerver IP cme, ahonnan a tzfal szinkronizlni fog.', 'ntp_ips', '148.6.0.1', 1),
		('Bels Mail Szerver', 'A bels mail szerver IP cme', 'Az intraneten lv mail szerver IP cme, ahova a tzfal tovbbt.', 'in_mail_ips', '', 1),
		('Kimen SMTP szerver', 'Kimen SMTP szerver IP cme', 'Az ISP ltal biztostott kimen SMTP szerver IP cme. (smart relay)', 'smtp_mail_ips', '', 1),
		('SMTP Domainek', 'A kiszolglt SMTP domainek', 'Azok a mail domainek amelynek cmzett levelet a tzfal elfogad.', 'smtp_mail_domains', '', 0),
		('DMZ szerver', 'DMZ szerver IP cme', 'A DMZ-ben tallhat publikus szerver IP cme', 'dmz_server', '', 1)
		)
config_no_dmz_list = ( ('Intranet intersz', 'Intranet interfsz', 'Az intranet oldali intersz azonostja.', 'intra_if', 'eth0', 0),
		('Intranet hlzati cme', 'Intranet hlzati cme ', 'Az intranet hlzati cme. (x.x.x.x/x).', 'intra_net', '', 2),
		('Intranet IP', 'Intranet oldali ip cm', 'Az intranet oldali interfsz IP cme.', 'intra_ip', '', 1),
		('Internet interfsz', 'Internet interfsz', 'Az Internet oldali interfsz azonostja.', 'inter_if', 'eth1', 0),
		('Internet IP', 'Internet oldali IP', 'Az Internet oldali interfsz IP cme.', 'inter_ip', '', 1),
		('DNS Szerver', 'DNS szerver IP cme', 'Az Internet szolgltat DNS szervernek IP cme', 'dns_ips', '193.225.86.1', 1),
		('NTP Szerver', 'NTP szerver IP cme', 'Egy kls NTP szerver IP cme, ahonnan a tzfal szinkronizlni fog.', 'ntp_ips', '148.6.0.1', 1),
		('Bels Mail Szerver', 'A bels mail szerver IP cme', 'Az intraneten lv mail szerver IP cme, ahova a tzfal tovbbt.', 'in_mail_ips', '', 1),
		('Kimen SMTP szerver', 'Kimen SMTP szerver IP cme', 'Az ISP ltal biztostott kimen SMTP szerver IP cme. (smart relay)', 'smtp_mail_ips', '', 1),
		('SMTP Domainek', 'A kiszolglt SMTP domainek', 'Azok a mail domainek amelynek cmzett levelet a tzfal elfogad.', 'smtp_mail_domains', '', 0),
		)


#
#################################################################################################
#


class TreeState:
	def __init__(self, title, label):
		self.title = title
		self.label = label
		self.width = 30
		self.initForm()
	
	def initForm(self):
		self.form = GridForm(UIUtils.screen, self.title, 1, 3)
		self.lb = Label(self.label)
		self.bb = ButtonBar(screen, 
				[("Minimlis", "min"),
				("Optimlis", "opt"),
				("Teljes", "full")],
				compact = 1,
				horizontal = 1)
			
		self.form.add(self.lb, 0, 0)
		self.form.add(self.bb, 0, 2)
	
	def run(self):
		x = self.form.run()
		UIUtils.screen.popWindow()
		x = self.bb.buttonPressed(x)
		return x

#
#################################################################################################
#


class Wizard:
	def __init__(self, title, label, help, default, width = 30):
		self.title = title
		self.label = label
		self.help = help
		self.default = default
		self.width = width
		self.initForm()
	
	def initForm(self):
		self.form = GridForm(UIUtils.screen, self.title, 1, 3)
		self.lb = Label(self.label)
		self.bb = ButtonBar(screen, 
				[(" Vissza ", "back"),
				(" Sg ", "help"),
				(" Kvetkez ", "next"),
				(" Kilp ", "quit")],
				compact = 1,
				horizontal = 1)
			
		self.entry = Entry(self.width, self.default, returnExit = 1)
		self.form.add(self.lb, 0, 0)
		self.form.add(self.entry, 0, 1)
		self.form.add(self.bb, 0, 2)
	
	def run(self):
		x = self.form.run()
		UIUtils.screen.popWindow()
		x = self.bb.buttonPressed(x)
		if x == "next" or x == None:
			return self.entry.value()
		elif x == "help":
			MessageForm(self.title, self.help).run()
			return x
		else:
			return x
#
#################################################################################################
#


def NtpConfig(config, filename = '/etc/ntp.conf'):
	try:
		f = open(filename, 'w')
		f.write("""
# /etc/ntp.conf, configuration for ntpd, generated by UZI
		
driftfile /var/lib/ntp/ntp.drift
statsdir /var/log/ntpstats/
		
statistics loopstats peerstats clockstats
filegen loopstats file loopstats type day enable
filegen peerstats file peerstats type day enable
filegen clockstats file clockstats type day enable
		
server %(ntp_ips)s
		""" % config)
		f.close()
	except IOError:
		UIUtils.MessageForm("Figyelem!", "A '%s' file mentse kzben I/O hiba trtnt." % filename).run()
		return 0
	return 1


#
#################################################################################################
#


def BindConfig(config, filename = '/etc/bind/named.conf'):
	try:
		f = open(filename, 'w')
		f.write("""
options {
        directory "/var/cache/bind";

        query-source address * port 53000;
        forward only;
        forwarders {
		%(dns_ips)s; 
        };
};
logging {
        category lame-servers { null; };
        category cname { null; };
};
zone "." {
        type hint;
        file "/etc/bind/db.root";
};
zone "localhost" {
        type master;
        file "/etc/bind/db.local";
};
zone "127.in-addr.arpa" {
        type master;
        file "/etc/bind/db.127";
};
zone "0.in-addr.arpa" {
        type master;
        file "/etc/bind/db.0";
};
zone "255.in-addr.arpa" {
        type master;
        file "/etc/bind/db.255";
};

// add entries for other zones below here
		""" % config)
		f.close()
	except IOError:
		UIUtils.MessageForm("Figyelem!", "A '%s' file mentse kzben I/O hiba trtnt." % filename).run()
		return 0
	return 1

#
#################################################################################################
#


def PostfixConfig(config, dir = '/etc/postfix'):
	try:
		filename = dir + '/main.cf'
		f = open(filename , 'w')
		f.write("""
command_directory = /usr/sbin
queue_directory = /var/spool/postfix
daemon_directory = /usr/lib/postfix
mail_owner = postfix
smtpd_recipient_restrictions = permit_mynetworks reject_unauth_destination
smtpd_banner = $myhostname ESMTP
local_transport = error:local mail delivery is disabled on this machine
mynetworks = 127.0.0.0/8 %(intra_net)s %(dmz_net)s
smtpd_banner = $myhostname ESMTP
program_directory = /usr/lib/postfix
myhostname = fw
myorigin = /etc/mailname
mydestination = %(smtp_mail_domains)s
relayhost = %(smtp_mail_ips)s
mailbox_size_limit = 0
transport_maps = hash:/etc/postfix/transport
append_dot_mydomain = no
		""" % config)
		f.close()
	except IOError:
		UIUtils.MessageForm("Figyelem!", "A '%s' file mentse kzben I/O hiba trtnt." % filename).run()
		return 0

	try:
		filename = dir + '/transport'
		f = open(filename , 'w')
		f.write("""
%(smtp_mail_domains)s		smtp:[%(in_mail_ips)s]
		""" % config)
		f.close()
	except IOError:
		UIUtils.MessageForm("Figyelem!", "A '%s' file mentse kzben I/O hiba trtnt." % filename).run()
		return 0


#
#################################################################################################
#


def IptablesConfig(config, use_dmz, dir = '/etc'):
	try:
		filename = dir + '/iptables.conf.var'
		f = open(filename , 'w')

		if use_dmz == 1:
			f.write("""
#define INTRA_IF	%(intra_if)s
#define INTRA_IP	%(intra_ip)s
#define INTRA_NET	%(intra_net)s

#define DMZ_IF		%(dmz_if)s
#define DMZ_IP		%(dmz_ip)s
#define DMZ_NET		%(dmz_net)s

#define INTER_IF	%(inter_if)s
#define INTER_IP	%(inter_ip)s	

#define NTP_IP		%(ntp_ips)s
#define DNS_IP		%(dns_ips)s
			""" % config)

		else:
			f.write("""
#define INTRA_IF	%(intra_if)s
#define INTRA_IP	%(intra_ip)s
#define INTRA_NET	%(intra_net)s

#define INTER_IF	%(inter_if)s
#define INTER_IP	%(inter_ip)s	

#define NTP_IP		%(ntp_ips)s
#define DNS_IP		%(dns_ips)s
			""" % config)


		f.close()
	except IOError:
		UIUtils.MessageForm("Warning", "An I/O error occurred while saving to '%s'." % filename).run()
		return 0


	try:
		filename = dir + '/iptables.conf.in'
		f = open(filename , 'w')
		if use_dmz == 1:
			f.write("""
*tproxy
:PREROUTING ACCEPT
:OUTPUT ACCEPT
:PRintra

-A PREROUTING -p tcp ! --syn -j DROP
-A PREROUTING -i INTRA_IF -d ! INTRA_IP -j PRintra

-A PRintra -p tcp -d 0/0 25 -j TPROXY --on-port 0
-A PRintra -p tcp -d 0/0 21 -j TPROXY --on-port 50021
-A PRintra -p tcp -d 0/0 23 -j TPROXY --on-port 50023
-A PRintra -p tcp -d 0/0 43 -j TPROXY --on-port 50043
-A PRintra -p tcp -d 0/0 79 -j TPROXY --on-port 50079
-A PRintra -p tcp -d 0/0 80 -j TPROXY --on-port 50080
-A PRintra -p tcp -d 0/0 110 -j TPROXY --on-port 50110
-A PRintra -p tcp -d 0/0 443 -j TPROXY --on-port 50443

-A PRintra -p tcp -d DMZ_NET 22 -j TPROXY --on-port 50022
COMMIT

*filter
:INPUT DROP
:FORWARD DROP
:OUTPUT ACCEPT
:LOintra -
:LOinter - 
:LOdmz -
:noise -
:spoof -
:spoofdrop DROP

-A INPUT -j spoof
-A INPUT -j noise

-A INPUT -m tproxy -j ACCEPT
-A INPUT -m state --state ESTABLISHED -j ACCEPT
-A INPUT -i lo -j ACCEPT
-A INPUT -i INTRA_IF -d INTRA_IP -j LOintra
-A INPUT -i DMZ_IF -d DMZ_IP -j LOdmz
-A INPUT -i INTER_IF -j LOinter
-A INPUT -j LOG
-A INPUT -j DROP

//LOintra
-A LOintra -p tcp -d 0/0 22 -j ACCEPT
-A LOintra -p tcp -d 0/0 25 -j ACCEPT
-A LOintra -p udp -d 0/0 53 -j ACCEPT
-A LOintra -p udp -d 0/0 123 -j ACCEPT
-A LOintra -p icmp -j ACCEPT
-A LOintra -j LOG
-A LOintra -j DROP

//LOinter
-A LOinter -p tcp -d 0/0 25 -j ACCEPT
-A LOinter -p udp -s NTP_IP 123 -d 0/0 123 -j ACCEPT
-A LOinter -p udp -s DNS_IP 53 -d 0/0 53000 -j ACCEPT
//to zorp
-A LOinter -p tcp -d 0/0 80 -j ACCEPT
-A LOinter -p tcp -d 0/0 443 -j ACCEPT
-A LOinter -p icmp -j ACCEPT
-A LOinter -j LOG
-A LOinter -j DROP

//LOdmz
-A LOdmz -p tcp -d 0/0 25 -j ACCEPT
-A LOdmz -p udp -s 0/0 123 -d 0/0 123 -j ACCEPT
-A LOdmz -p udp -d 0/0 53 -j ACCEPT
-A LOdmz -p icmp -j ACCEPT
-A LOdmz -j LOG
-A LOdmz -j DROP

//spoof
-A spoof -i ! lo -s 127.0.0.1 -j spoofdrop
-A spoof -i ! lo -d 127.0.0.1 -j spoofdrop
-A spoof -i INTER_IF -s INTRA_NET -j spoofdrop
-A spoof -i INTER_IF -d INTRA_NET -j spoofdrop
-A spoof -i INTRA_IF -s ! INTRA_NET -j spoofdrop
-A spoof -i DMZ_IF -s ! DMZ_NET -j spoofdrop
-A spoof -j RETURN

//spoofdrop
-A spoofdrop -j LOG
-A spoofdrop -j DROP

//noise
-A noise -d 255.255.255.255 -j DROP
-A noise -j RETURN

COMMIT

*nat
:PREROUTING ACCEPT
:POSTROUTING ACCEPT
:OUTPUT ACCEPT
COMMIT
			""" % config)

		else:
			f.write("""
*tproxy
:PREROUTING ACCEPT
:OUTPUT ACCEPT
:PRintra

-A PREROUTING -p tcp ! --syn -j DROP
-A PREROUTING -i INTRA_IF -d ! INTRA_IP -j PRintra

-A PRintra -p tcp -d 0/0 25 -j TPROXY --on-port 0
-A PRintra -p tcp -d 0/0 21 -j TPROXY --on-port 50021
-A PRintra -p tcp -d 0/0 23 -j TPROXY --on-port 50023
-A PRintra -p tcp -d 0/0 43 -j TPROXY --on-port 50043
-A PRintra -p tcp -d 0/0 79 -j TPROXY --on-port 50079
-A PRintra -p tcp -d 0/0 80 -j TPROXY --on-port 50080
-A PRintra -p tcp -d 0/0 110 -j TPROXY --on-port 50110
-A PRintra -p tcp -d 0/0 443 -j TPROXY --on-port 50443

COMMIT

*filter
:INPUT DROP
:FORWARD DROP
:OUTPUT ACCEPT
:LOintra -
:LOinter - 
:noise -
:spoof -
:spoofdrop DROP

-A INPUT -j spoof
-A INPUT -j noise

-A INPUT -m tproxy -j ACCEPT
-A INPUT -m state --state ESTABLISHED -j ACCEPT
-A INPUT -i lo -j ACCEPT
-A INPUT -i INTRA_IF -d INTRA_IP -j LOintra
-A INPUT -i INTER_IF -j LOinter
-A INPUT -j LOG
-A INPUT -j DROP

//LOintra
-A LOintra -p tcp -d 0/0 22 -j ACCEPT
-A LOintra -p tcp -d 0/0 25 -j ACCEPT
-A LOintra -p udp -d 0/0 53 -j ACCEPT
-A LOintra -p udp -d 0/0 123 -j ACCEPT
-A LOintra -p icmp -j ACCEPT
-A LOintra -j LOG
-A LOintra -j DROP

//LOinter
-A LOinter -p tcp -d 0/0 25 -j ACCEPT
-A LOinter -p udp -s NTP_IP 123 -d 0/0 123 -j ACCEPT
-A LOinter -p udp -s DNS_IP 53 -d 0/0 53000 -j ACCEPT
-A LOinter -p icmp -j ACCEPT
-A LOinter -j LOG
-A LOinter -j DROP

//spoof
-A spoof -i ! lo -s 127.0.0.1 -j spoofdrop
-A spoof -i ! lo -d 127.0.0.1 -j spoofdrop
-A spoof -i INTER_IF -s INTRA_NET -j spoofdrop
-A spoof -i INTER_IF -d INTRA_NET -j spoofdrop
-A spoof -i INTRA_IF -s ! INTRA_NET -j spoofdrop
-A spoof -j RETURN

//spoofdrop
-A spoofdrop -j LOG
-A spoofdrop -j DROP

//noise
-A noise -d 255.255.255.255 -j DROP
-A noise -j RETURN

COMMIT

*nat
:PREROUTING ACCEPT
:POSTROUTING ACCEPT
:OUTPUT ACCEPT
COMMIT
			""" % config)
		f.close()
	except IOError:
		UIUtils.MessageForm("Figyelem!", "A '%s' file mentse kzben I/O hiba trtnt." % filename).run()
		return 0
			

#
#################################################################################################
#


def LoadConfig():

	try:
		f = open(path_uzi_db, 'r')
		cfg = cPickle.load(f)
		f.close()
	except IOError:
		cfg = {}
	
	return cfg


#
#################################################################################################
#


def SaveConfig(config):

	try:
		f = open(path_uzi_db, 'w')
		cPickle.dump(config, f)
		f.close()
	except IOError:
		UIUtils.MessageForm("Figyelem!", "A '%s' adatbzis mentse kzben I/O hiba trtnt.", path_uzi_db).run()
		return 0
	return 1


#
#################################################################################################
#
		

def main():
	try:
		cfg = LoadConfig()
		Initialize("uzi version %s" % (version,))

		ip_address = compile("^\d+.\d+.\d+.\d+$")
		net_address = compile("^\d+.\d+.\d+.\d+/\d+$")

		dmz = UIUtils.YesNoForm("A tzfal DMZ-t is vdeni fog?").run()
		if dmz == "nem":
			config_list = config_no_dmz_list
			dmz_s = ""
			use_dmz = 0 
			cfg['dmz_net'] = ""
			
		else:
			config_list = config_dmz_list
			dmz_s = "-dmz"
			use_dmz = 1
			
		type = TreeState('Config type', 'Milyen b legyen tzfal ltal engedlyezett szolgltatsok kre?').run()
		zui_config = "zorp" + dmz_s + "-" + type + "@fw"
		
		cfg_func = 0
		quit = 0 

		while (cfg_func < len(config_list)) and (not quit):
			if not cfg.has_key(config_list[cfg_func][3]):
				cfg[config_list[cfg_func][3]] = config_list[cfg_func][4]

			x = Wizard(config_list[cfg_func][0], config_list[cfg_func][1],
					config_list[cfg_func][2], cfg[config_list[cfg_func][3]]).run()
			if x == "help":
				pass
			elif x == "quit":
				quit = 1
			elif x == "back":
				if cfg_func == 0:
					cfg_func = 0
				else:
					cfg_func = cfg_func - 1
			else:
				if config_list[cfg_func][5] == 1:
					if not match(ip_address, x):
						UIUtils.MessageForm("Figyelem!", "Nem IP cm formtum='%s'." % x).run()
						continue

				if config_list[cfg_func][5] == 2:
					if not match(net_address, x):
						UIUtils.MessageForm("Figyelem!", "Nem hlzati cm formtum='%s'. (Tipp: x.x.x.x/x)" % x).run()
						continue
						
				cfg[config_list[cfg_func][3]] = x
				cfg_func = cfg_func + 1


		if not quit:

			NtpConfig(cfg)
			BindConfig(cfg)
			PostfixConfig(cfg)
			IptablesConfig(cfg, use_dmz)
	
	
			i = open(path_zui_db_pre, 'r')
			cfg_str = i.read()
			i.close()
	
	
			for valt in cfg.keys():
				tmp_str = sub(valt, cfg[valt], cfg_str)
				cfg_str = tmp_str
	
			o = open(path_zui_db, 'w')
			o.write(cfg_str)
			o.close()
	
	
	
			zcfg = ZorpConfig.ZorpConfig(zui_config)
			f = open(path_zui_db, 'r')
			zcfg = cPickle.load(f)
			f.close()
			zcfg[zui_config].genConfig()


			SaveConfig(cfg)
		Deinitialize()
	except:
		Deinitialize()
		traceback.print_exc()

#
#################################################################################################
#

if __name__ == "__main__":
	main()
